-- image_readfile sample application
--
-- this example shows how you can read a variety of types of file
--
-- requires:
--	<nothing> but perhaps some sample files to load
--
-- Store Installation location into asinstdir table.
if exists(select * from SYS.SYSTABLE where table_name='asainstdir') then
    drop table asainstdir
end if
go

create table asainstdir (location char(1024))
go
call xp_cmdshell('echo $ASANY9 > /tmp/envout')
go
insert into asainstdir values (xp_read_file('/tmp/envout'))
go
update asainstdir set location =  substring(location,1,length(location)-1) 
go
commit
go

call sa_make_object( 'procedure' ,'readasadocfile')
go
alter procedure readasadocfile( filename varchar(250) )
result (rawdoc long binary)
begin
	declare image long binary;
	declare dir long varchar;
	declare reldir char(10);
	declare pos int;
	declare pos2  int;
	set pos = locate( filename ,'html' );
	if pos = 0 then 
		set pos = locate( filename ,'pdf' );
	end if;
	set pos2 = locate( filename ,'/', -1);
	set reldir = substring( filename , pos+5  , pos2-pos-5);
	if reldir = 'c' then
		set reldir = '';
	elseif substr(reldir ,1 ,1)='/' and 
		substring (reldir , -2,2) = '/.' then
		set reldir = substring( reldir , 2, length(reldir)-3);
	elseif substr(reldir ,1 ,6)='ix/../' then 
		set reldir = substring( filename , pos+11  , pos2-pos-11);
	end if;
	
	set dir = (select location from asainstdir);
	if substring(filename,1,7) = '$ASANY9' then
		set filename = replace(filename , '$ASANY9', dir );
	elseif (substring(filename,1,2) = 'db' or substring(filename,1,2) = 'ul' )  
		and substring(filename,9,1) ='/'  then
		set filename = replace(filename , '$ASANY9', dir||'/docs/help/' );
	end if;
	set image = xp_read_file( filename );
	if image is NULL then
		call sa_set_http_header( 'Content-Type', 'text/plain' );
		set image = 'Oops: Image ' || filename || ' not found\n';
		set image = csconvert( image, connection_property('CharSet') );
	else
		case
		when right( filename, 4 ) = '.txt' or right( filename, 4 ) = '.sql' then
			call sa_set_http_header( 'Content-Type', 'text/plain' );
			set image = csconvert( image, connection_property('CharSet') );
		when right( filename, 4 ) = '.js' or right( filename, 4 ) = '.js' then
			call sa_set_http_header( 'Content-Type', 'text/plain' );
			set image = csconvert( image, connection_property('CharSet') );

		when right( filename, 4 ) = '.htm' then
			call sa_set_http_header( 'Content-Type', 'text/html' );
			set image = replace(image, 'HREF="http','FEFH=http');
			set image = replace(image, 'HREF="../../html','FERHh="serveasadoc?url=$ASANY9/docs/en/html');
			set image = replace(image, 'HREF="../html','FERHh="serveasadoc?url=$ASANY9/docs/en/html');
			set image = replace(image, 'HREF="../contents.htm','FERHh="serveasadoc?url=$ASANY9/docs/en/html/contents.htm');
			set image = replace(image, 'HREF="../../pdf','FERHp="serveasadoc?url=$ASANY9/docs/en/pdf');
			set image = replace(image, 'HREF="../pdf','FERHp="serveasadoc?url=$ASANY9/docs/en/pdf');
			if reldir = 'co' then
				set image = replace(image, 'HREF="','HREF="serveasadoc?url=$ASANY9/docs/en/pdf/');
			else
				set image = replace(image, 'HREF="','HREF="serveasadoc?url=$ASANY9/docs/en/html/'||reldir||'/');
			end if;
			set image = replace(image, 'onClick="openPDFInNewWindow( ''../../pdf','href=''serveasadoc?url=$ASANY9/docs/en/pdf');
			set image = replace(image, 'FEFH=http','HREF="http');
			set image = replace(image, 'FERHp="serveasadoc','HREF="serveasadoc');
			set image = replace(image, 'FERHh="serveasadoc','HREF="serveasadoc');
			if reldir = 'co' then
				set image = replace(image, ' SRC="',' SRC="serveasadoc?url=$ASANY9/docs/en/pdf/');
			else
				set image = replace(image, ' SRC="',' SRC="serveasadoc?url=$ASANY9/docs/en/html/'||reldir||'/');
			end if;
			set image = replace(image, ' SRC=''',' SRC=''serveasadoc?url=$ASANY9/docs/en/html/'||reldir||'/');
			set image = replace(image, 'img src=gif/','IMG SRC="serveasadoc?url=$ASANY9/docs/en/html/'||reldir||'gif/');
		when  right(filename ,10)=  'index.html' then
			call sa_set_http_header( 'Content-Type', 'text/html' );
			set image = replace(image, ' src="contents.htm"',' src="serveasadoc?url=$ASANY9/docs/en/html/contents.htm"');
			set image = replace(image, ' src="ix/00000.htm"',' src="serveasadoc?url=$ASANY9/docs/en/html/ix/00000.htm"');
		when  right(filename ,5)=  '.html' then
			call sa_set_http_header( 'Content-Type', 'text/html' );
		when right( filename, 4 ) = '.bmp' then
			call sa_set_http_header( 'Content-Type', 'image/bmp' );
			call sa_set_http_header( 'Content-Type', 'image/bmp' );
		when right( filename, 4 ) = '.jpg' or right( filename, 5 ) = '.jpeg' then
			call sa_set_http_header( 'Content-Type', 'image/jpeg' );
		when right( filename, 4 ) = '.gif' then
			call sa_set_http_header( 'Content-Type', 'image/gif' );

		when right( filename, 4 ) = '.wav' then
			call sa_set_http_header( 'Content-Type', 'audio/x-wav' );
		when right( filename, 4 ) = '.mp3' then
			call sa_set_http_header( 'Content-Type', 'audio/mp3' );
		when right( filename, 4 ) = '.mpg' then
			call sa_set_http_header( 'Content-Type', 'video/mpeg' );

		when right( filename, 4 ) = '.tar' then
			call sa_set_http_header( 'Content-Type', 'application/x-tar' );
		when right( filename, 4 ) = '.zip' then
			call sa_set_http_header( 'Content-Type', 'application/x-zip' );
		when right( filename, 4 ) = '.pdf' then
			call sa_set_http_header( 'Content-Type', 'application/pdf' );
		else
			-- ? what type is it? you can add to the above list of types
			-- we'll assume jpeg (but its only a guess)
			call sa_set_http_header( 'Content-Type', 'image/jpeg' );
		end case;
		call sa_set_http_header( 'Content-Length', string(length(image)) );
	end if;
	select image;
end;
go

if exists(select * from SYS.SYSWEBSERVICE where service_name='serveasadoc') then
    drop service serveasadoc
end if
go

create service serveasadoc type 'raw' authorization off user dba url on
    as call readasadocfile( :url )
go
